﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace TBmemo
{
    public partial class Option : Form
    {
        Form1 _mainForm;
        Color bgColor;


        public Form1 mainForm
        {
            get { return _mainForm; }
            set { _mainForm = value; }
        }

        

        public Option(Form1 form)
        {
            InitializeComponent();
            mainForm = form;
            OptionInitializeComponent();
        }

        //設定した項目をメインのフォームに反映させる
        public void SetOption()
        {
            mainForm.Opacity = 1 - ((double) OpacityNumericUpDown.Value * 0.01);
            if (BgcolRadioButton.Checked)
            {
                mainForm.TBox.BackColor = bgColor;
                if (mainForm.imgForm != null)
                {
                    mainForm.Owner = null;
                    mainForm.imgForm.Close();
                    mainForm.imgForm = null;
                }
            }
            else
            {
                if(BgimgPictureBox.Image != null)
                    SetImgForm();
            }
        }

        //オプションの各項目の初期化を行う
        private void OptionInitializeComponent()
        {            
            OpacityNumericUpDown.Value = 100 - ((decimal)mainForm.Opacity * 100);
            if (mainForm.imgForm == null)
            {
                BgcolRadioButton.Checked = true;
                bgColor = mainForm.TBox.BackColor;
                NowColPictureBox.BackColor = bgColor;
            }
            else
            {
                BgimgRadioButton.Checked = true;
                BgimgPictureBox.Image = mainForm.imgForm.PictureBox1.Image;
                if (mainForm.imgForm.PictureBox1.SizeMode == PictureBoxSizeMode.StretchImage)
                    StretchimgCheckBox.Checked = true;
            }

            CheckedChange();
        }

        //BgcolRadioButtonのチェック状態が変わったときに呼ばれるイベントハンドラ
        private void BgcolRadioButton_CheckedChange(object sender, EventArgs e)
        {
            CheckedChange();
        }

        //背景タブの各コントロールの有効/無効を切り替える
        private void CheckedChange()
        {
            if (BgcolRadioButton.Checked)
            {
                BgimgLabel.Enabled = false;
                BgimgPictureBox.Enabled = false;
                BgimgChangeButton.Enabled = false;
                OpacityimgLabel.Enabled = false;
                OpacityimgNumericUpDown.Enabled = false;
                StretchimgCheckBox.Enabled = false;
                NowColLabel.Enabled = true;
                NowColPictureBox.Enabled = true;
                ColChangeButton.Enabled = true;                
            }
            else
            {
                BgimgLabel.Enabled = true;
                BgimgPictureBox.Enabled = true;
                BgimgChangeButton.Enabled = true;
                OpacityimgLabel.Enabled = true;
                OpacityimgNumericUpDown.Enabled = true;
                StretchimgCheckBox.Enabled = true;
                NowColLabel.Enabled = false;
                NowColPictureBox.Enabled = false;
                ColChangeButton.Enabled = false;
            }
        }        

        //「背景色を変更」ボタンを押したときのイベントハンドラ
        private void ColChangeButton_Click(object sender, EventArgs e)
        {
            DialogResult dr = colorDialog1.ShowDialog();

            if (dr == DialogResult.OK)
            {
                bgColor = colorDialog1.Color;
                NowColPictureBox.BackColor = bgColor;
            }
                
        }

        //背景画像を変更ボタンが押されたときのイベントハンドラ
        private void BgimgChangeButton_Click(object sender, EventArgs e)
        {
            DialogResult dr = openFileDialog1.ShowDialog();

            if (dr == DialogResult.OK)
                BgimgPictureBox.Image = new Bitmap(openFileDialog1.FileName);
                             
        }

        //メインフォームのテキスト編集領域に背景画像を疑似的に設定
        private void SetImgForm()
        {           

            mainForm.TBox.BackColor = Color.DimGray;
            mainForm.TransparencyKey = Color.FromKnownColor(KnownColor.DimGray);

            ImgForm imgF = new ImgForm(mainForm);

            imgF.PictureBox1.Image = BgimgPictureBox.Image;
            imgF.AddOwnedForm(mainForm);
            imgF.Size = mainForm.Size;            

            if(mainForm.imgForm != null)
                mainForm.imgForm.Close();            

            if (StretchimgCheckBox.Checked)
                imgF.PictureBox1.SizeMode = PictureBoxSizeMode.StretchImage;

            imgF.Show();
            imgF.Location = mainForm.Location;
            mainForm.imgForm = imgF;
        }


    }
}
